Subject: Re: Several races in "usbnet" module (kernel 4.1.x)

From: Eugene Shatokhin <[email-masked]>
Date: Thu, 23 Jul 2015 14:39:42 +0300

23.07.2015 12:43, Oliver Neukum пишет:
> On Mon, 2015-07-20 at 21:13 +0300, Eugene Shatokhin wrote:
>> [Race #5]
>>
>> Race on dev->rx_urb_size. I reproduced it a similar way as the races
>> #2
>> and #3 (changing MTU while downloading files).
>>
>> dev->rx_urb_size is written to here:
>> #0  usbnet_change_mtu (usbnet.c:392)
>>          dev->rx_urb_size = dev->hard_mtu;
>>
>> Here is the conflicting read from dev->rx_urb_size:
>> * rx_submit (usbnet.c:467)
>>          size_t                  size = dev->rx_urb_size;
>
> Yes, but what is the actual bad race? I mean, if you change
> the MTU in operation, there will be a race. That is just
> unavoidable.
> Do we generate errors?

No, I have observed no problems due to this race so far.

Regards,
Eugene